package org.computer.aman.metrics.size.loc;

import java.io.IOException;

import org.computer.aman.io.sourcecode.NotSupportedSourceFileExeption;
import org.computer.aman.io.sourcecode.SourceFile;

/**
 * ñΥեˤĤ LOC ¬Ȥ˴Ϣ뵡ǽ
 * <p>
 * @author Hirohisa AMAN &lt;aman@computer.org&gt;
 * @version $Id: LOC.java,v 1.2 2009/01/07 12:11:19 aman Exp $ 
 */
public class LOC
{
    /**
     * LOC ¬¹Ԥ̤ ResultSet 󥹥󥹤Ȥ֤
     * 
     * @param aSourceFile ¬оݤΥե
     * @return LOC ¬η
     * @throws IOException 
     * @throws NotSupportedSourceFileExeption ݡȳΥեξ
     */
    public static LOCResultSet measure(final SourceFile aSourceFile)
    throws NotSupportedSourceFileExeption, IOException
	{
        return measure(aSourceFile, 1, -1);
	}
    
    /**
     * LOC ¬¹Ԥ̤ ResultSet 󥹥󥹤Ȥ֤
     * 
     * @param aSourceFile ¬оݤΥե
     * @param aBeginLineNumber ¬γϹ
     * @return LOC ¬η
     * @throws IOException 
     * @throws NotSupportedSourceFileExeption ݡȳΥեξ
     */
    public static LOCResultSet measure(final SourceFile aSourceFile, final int aBeginLineNumber)
    throws NotSupportedSourceFileExeption, IOException
    {
        return measure(aSourceFile,aBeginLineNumber,-1);
    }

    /**
     * LOC ¬¹Ԥ̤ ResultSet 󥹥󥹤Ȥ֤
     * 
     * @param aSourceFile ¬оݤΥե
     * @param aBeginLineNumber ¬γϹ
     * @param anEndLineNumber ¬νλԡ-1 ξޤǡ
     * @return LOC ¬η
     * @throws IOException 
     * @throws NotSupportedSourceFileExeption ݡȳΥեξ
     */
    public static LOCResultSet measure(final SourceFile aSourceFile, final int aBeginLineNumber, final int anEndLineNumber)
    throws NotSupportedSourceFileExeption, IOException
    {
        // եγĥҤ˹碌ƥ֥饹¬Ѿ
        if ( aSourceFile.getExtension().equals("java") ){
            return LOCForJava.measure(aSourceFile, aBeginLineNumber, anEndLineNumber);
        }

        throw new NotSupportedSourceFileExeption("not supported file type: " + aSourceFile);    
    }
}
