package org.computer.aman.metrics.size.loc;

import java.io.FileReader;
import java.io.IOException;
import java.io.LineNumberReader;

import org.computer.aman.io.sourcecode.SourceCodeLine;
import org.computer.aman.io.sourcecode.SourceFile;

/**
 * ñ Java եˤĤ LOC ¬Ȥ˴Ϣ뵡ǽ
 * <p>
 * @author Hirohisa AMAN &lt;aman@computer.org&gt;
 * @version $Id: LOCForJava.java,v 1.2 2009/01/07 12:11:20 aman Exp $ 
 */
public class LOCForJava extends LOC
{
    /**
     * LOC ¬¹Ԥ̤ LOCResultSet 󥹥󥹤Ȥ֤
     * 
     * @param aSourceFile ¬оݤΥե
     * @param aBeginLineNumber ¬γϹ
     * @param anEndLineNumber ¬νλԡ-1 ξޤǡ
     * @return LOC ¬η
     * @throws IOException
     */
	public static LOCResultSet measure(final SourceFile aSourceFile, final int aBeginLineNumber, final int anEndLineNumber) 
	throws IOException 
	{
        // status - ɲϤξ
	    //   0 : 
	    //   1 : 餫ͭʥɤɤ߽Ф
	    //   11: EOL ȡ//...
	    //   12: Traditional ȡ/* ... 
	    //   100: ʸƥ"..."
        int status = 0; 
				
		// 1 Ԥɤ߹ߡƤˤĤĴ٤ʤ LOC ͤ򥫥ȤƤ
        LineNumberReader reader = new LineNumberReader(new FileReader(aSourceFile));
        int loc = 0;
		LOCResultSet result = new LOCResultSet(aSourceFile);
        String line = null;
        int lineNumber = 0;
		while ( (line = reader.readLine()) != null ){
		    lineNumber++; // lineNumber ߤιֹ򼨤
		    if ( lineNumber < aBeginLineNumber ){
		        continue;
		    }
		    if ( anEndLineNumber > 0 && anEndLineNumber < aBeginLineNumber ){
		        continue;
		    }
		    if ( lineNumber-1 == anEndLineNumber ){
		        break;
		    }
		    		    
			// ιԤ˲餫ͭʥɤޤޤ뤫ݤΥե饰Ѱ
			boolean isCodeIncluded = false;

			// 1 ʸĴ١֤ܤƤ
			int i = 0;
			while ( i < line.length() ){	
				char ch = line.charAt(i);
				if ( Character.isWhitespace(ch) ){
					// ۥ磻ȥڡʤɤФ
					i++;
					continue;
				}
				
				switch ( status ){
				case 0: // 
				case 1: // ̾Υ
					switch ( ch ){
					case '/' :  // ȳϤβǽ
						//  1 ʸĴ٤Ƽξ֤ꤹ					    
                        i++;
                        status = 1; // ǥեȤϸݻ
						if ( i < line.length() ){
							ch = line.charAt(i);
							if ( ch == '/' ){
								status = 11; // EOL 
							}
							else if ( ch == '*' ){
								status = 12; // Traditional 
							}
						}
						break;
					case '\'' :
						if ( i+1 < line.length() ){
							// ̤ '"' ξ򥹥å
							if ( line.charAt(i+1) == '"' ){
								i += 2;
							}
							else // ʸξƱͤ˥å
								if ( line.charAt(i+1) == '\\' ){
								i += 3;
							}
						}
						break;
					case '"' :
						status = 100; // -->ʸλϤޤ
						break;
					default:
						status = 1; // -->̾Υ
						isCodeIncluded = true;							
					}
					break;
				case 11: // EOL 
					// ޤǥåפƽ֤
					i = line.length();
					status = 0; 
					break;
				case 12: // Traditional 
					if ( ch == '*' ){
						//  1 ʸĴ٤Ƽξ֤
						i++;
						if ( i < line.length() ){
							ch = line.charAt(i);
							if ( ch == '/' ){
								status = isCodeIncluded ? 1 : 0; // Ȥξ֤
							}
						}
					}
					break;
				case 100: // ʸ
					switch( ch ){
					case '"' :
						status = 1;
						break;
					case '\\' :
						i++; // 1 ʸå
					}
					break;
				}
				i++;
			}
			
			// ԤβϤä顤η̤ѿ loc  LOCResultSet ȿǤ
			if ( isCodeIncluded ){
				loc++;
			}			
			SourceCodeLine codeLine = new SourceCodeLine(line);
			codeLine.setLineNumber( isCodeIncluded ? loc : -1);
			result.addContents(codeLine);
			result.setLOC(loc);
		}
				
		return result;
	}
}
