package org.computer.aman.metrics.size.loc;

import java.util.ArrayList;
import java.util.Iterator;

import org.computer.aman.io.sourcecode.SourceCodeLine;
import org.computer.aman.io.sourcecode.SourceFile;

/**
 * LOC ¬η̽
 * <p>
 * @author Hirohisa AMAN &lt;aman@computer.org&gt;
 * @version $Id: LOCResultSet.java,v 1.1 2008/08/19 03:19:56 aman Exp $ 
 */
public class LOCResultSet
{
	/**
	 * LOC ¬ˤ̽Υ󥹥󥹤
	 */
	public LOCResultSet(final SourceFile aSourceFile)
	{
	    loc = -1;
		lines = new ArrayList<SourceCodeLine>();
		sourceFile = aSourceFile;
	}

	/**
	 * LOC ¬ʪȤ
	 * SourceCodeLine 󥹥󥹡ʳƥɹԤƤȤΥפ
	 * ꥹȤɲä
	 * 
	 * @param aCodeLine SourceCodeLine 󥹥
	 */
	public void addContents(final SourceCodeLine aCodeLine)
	{
		lines.add(aCodeLine);
	}
	
	/**
	 * LOC ֤ͤ
	 * 
	 * @return LOC 
	 */
	public int getLOC()
	{
	    if ( loc != -1 ){
	        return loc;
	    }
	    
		loc = 0;
		for ( Iterator<SourceCodeLine> itr = iterator(); itr.hasNext(); ){
			SourceCodeLine line = itr.next();
			if ( line.getLineNumber() != -1 ){
				loc++;
			}
		}		
		return loc;
	}

	/**
     * ¬оݤΥե֤
     *
     * @return ¬оݤΥե
     */
    public SourceFile getSourceFile()
    {
        return sourceFile;
    }
	
	/**
	 * եԿʥȡԤޤˤ֤
	 * 
	 * @return եԿʥȡԤޤ
	 */
	public int getTotalLineCount()
	{
		return lines.size();
	}

	/**
	 * LOC ¬ʪȤ
	 * SourceCodeLine 󥹥󥹡ʳƥɹԤƤȤΥפ
	 * ΥꥹȤ򥤥ƥ졼Ȥ֤
	 *  
	 * @return SourceCodeLine ꥹȤΥƥ졼
	 */
	public Iterator<SourceCodeLine> iterator()
	{
		return lines.iterator();
	}
	
	/**
	 * LOC ͤꤹ
	 * 
	 * @param aLOC LOC 
	 */
	public void setLOC(final int aLOC)
	{
	    loc = aLOC;
	}
	
	/**
	 * ¬̤ξܺ٤ʸȤ֤
	 * 
	 * @return ¬̤ξܺ
	 */
	public String toString()
	{
		StringBuffer buf = new StringBuffer();
		buf.append("[" + sourceFile.getName() + "]\n");
		buf.append("LOC = " + getLOC() + "\n");
		
		buf.append("Կ = " + getTotalLineCount() + "\n\n");
		
		buf.append("--ʥɤơ--------------------------------------\n");
        for (Iterator<SourceCodeLine> itr = iterator(); itr.hasNext(); ){
        	buf.append(itr.next());
        	buf.append("\n");
        }
		buf.append("--ʥɤƤޤǡ------------------------------\n");

        return new String(buf);
	}

    /** SourceCodeLine 󥹥󥹤ΤΥꥹ */
	private ArrayList<SourceCodeLine> lines;
	
	/** LOC  */
	private int loc;
	
	/** ¬оݤΥե */
	private SourceFile sourceFile;
}
